<?php

/**
 * @file 
 */

class Matrix {
  var $_row_keys= array();
  var $_col_keys= array();
  var $_A = array();

  function set_row_keys( $keys){
    $this->_row_keys= $keys;
  }

  function set_col_keys( $keys){
    $this->_col_keys= $keys;
  }

  function set_value( $row, $col, $value){
    $this->_A[$row][$col]= $value;
  }

  function get_value( $row, $col){
    return $this->_A[$row][$col];
  }

  /**
   * @name replace all occurences of key with value
   */
  function replace_vars( $vars){
    foreach( $this->_A as $row=> $cols){
      foreach( $cols as $col=> $value){
        // is it a number or a variable 
        if( !is_numeric( $value)){
          // Is it minus variable
          if(strpos($value, '-')===0){
            $key= substr($value,1);
            $value= -$vars[$key];
          } 
          else {
            $key= $value;
            $value= $vars[$key];
          }
          $this->set_value( $row, $col, $value);
        }
      }
    }
  }

  function _fill_empty(){
    foreach( $this->_row_keys as $row){
      foreach( $this->_col_keys as $col){
        if( is_null($this->_A[$row][$col])){
          $this->_A[$row][$col]=0;
        }
      }
    }
  }

  function _print( $show_keys= true, $separator="\t"){
    if( $show_keys){
      foreach( $this->_col_keys as $col){
        print $separator . $col; 
      }
      print "\n";
    }

    foreach( $this->_row_keys as $row){
      if( $show_keys){
        print $row . $separator;
      }
      foreach( $this->_col_keys as $col){
        print $this->get_value($row,$col) . $separator;
      }
      print "\n";
    }
  }

  function transpose(){
    $r= new Matrix();
    $r->set_row_keys( $this->_col_keys);
    $r->set_col_keys( $this->_row_keys);

    foreach( $this->_row_keys as $row){
      foreach( $this->_col_keys as $col){
        $r->set_value( $col, $row, $this->get_value($row,$col));
      }
    }
    return $r;
  }

  function to_array(){
    $return = array();
    $r=0;
    foreach( $this->_row_keys as $row){
      $c=0;
      foreach( $this->_col_keys as $col){
        $value= $this->get_value($row,$col);
        $return[$r][$c]= $value ? $value : 0;
        $c++;
      }
      $r++;
    }
    return $return;
  }
}

